package draggableCurve.shapes;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.awt.geom.*;

import javax.swing.*;



public class DraggableCurve {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				MouseFrame frame = new MouseFrame();
		//		frame.setde
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				frame.setVisible(true);
			}
		});
	}
}

class MouseFrame extends JFrame
{
   public MouseFrame()
   {
      setTitle("CurveTest");
      setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

      // add component to frame

      MyMouseComponent component = new MyMouseComponent();
      add(component);
   }

   public static final int DEFAULT_WIDTH = 1200;
   public static final int DEFAULT_HEIGHT = 800;
}


class MyMouseComponent extends JComponent {
	public MyMouseComponent() {
		//points = makePoints3(new SinFunction(),0,400,1000,1000);
		points = makePoints3(new SinFunction(),0,400,100,300);
		//current = null;

		
		addMouseListener(new MouseHandler());
		addMouseMotionListener(new MouseMotionHandler());
	}

	
	/**߸ļ
	 * @param startX	ߵĳʼ,X
	 * @param startY	ߵĳʼ,Y
	 * @param width		ߵĿ
	 * @param n			ߵĵĿԽԽȷ
	 * @return			ߵĵ
	 */
	public static ArrayList<Point2D> makePoints(double startX,double startY,double width, int n){
		ArrayList<Point2D> points = new ArrayList<Point2D>();
		points.add(new Point2D.Double(startX, startY));
		//System.out.println("startX="+startX+" startY="+startY);
		
		double x=0,y=0;
		for(int i = 0; i < n; i++){
			x = i * width / n;
			y = -300*(Math.sin(2*Math.PI*i/n));
			points.add(new Point2D.Double(startX+x,startY+y));
		}
		return points;
	}
	
	public static ArrayList<Point2D> makePoints2(double startX,double startY,double width, int n){
		ArrayList<Point2D> points = new ArrayList<Point2D>();
		points.add(new Point2D.Double(startX, startY));
		double times = width / (2 * Math.PI);
		double x=0,y=0;
		for(int i = 0; i < n; i++){
			x = 2*Math.PI * i / n;
			y = -Math.sin(x);
			points.add(new Point2D.Double(startX+times*x,startY+times*y));
		}
		return points;
	}
	
	public static ArrayList<Point2D> makePoints3(Function function,double startX,double startY,double times, int n){
		ArrayList<Point2D> points = new ArrayList<Point2D>();
		points.add(new Point2D.Double(startX, startY));
	//	double times = width / (2 * Math.PI);
		double x=0, y=0, segment=0;
		for(int i = 0; i < n; i++){
			segment = (double) i / n;
			Function.PairValue pariValue = function.caculatePoints(segment);
			x = pariValue.getX();
			y = pariValue.getY();
			points.add(new Point2D.Double(startX+times*x,startY+times*y));
		}
		return points;
		
	//	return null;
	}
	
	

	public void paintComponent(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		// convert points to line 
		Point2D[] allPoints = points.toArray(new Point2D[0]);
		int nPoints = allPoints.length;
		int xPoints[] = new int[nPoints];
		int yPoints[] = new int[nPoints];

		
		for(int i = 0;i < nPoints; i++){
			xPoints[i] = (int)allPoints[i].getX();
			yPoints[i] = (int)allPoints[i].getY();
		}
		g2.drawPolyline(xPoints, yPoints, nPoints);
//		System.out.println("xPoints[0]="+xPoints[0]+" yPoints[0]="+yPoints[0]);
//		System.out.println("xPoints[nPoints-1]="+xPoints[nPoints-1]+" yPoints[nPoints-1]="+yPoints[nPoints-1]); 
	}
	
	

	/**
	 * Finds the first square containing a point.
	 * 
	 * @param p
	 *            a point
	 * @return the first square that contains p
	 */
	public Point2D find(Point2D p) {
		for (Point2D r : points) {
			if ((Math.abs(r.getX()-p.getX())<10) &&  
			   (Math.abs(r.getY()-p.getY()))<10)
				return r;

			//System.out.println("x=,y="+p.getX()+" "+p.getY());
		}
		return null;
	}

	/**
	 * Adds a square to the collection.
	 * 
	 * @param p
	 *            the center of the square
	 */
//	public void add(Point2D p) {
//		double x = p.getX();
//		double y = p.getY();
//
//		current = new Rectangle2D.Double(x - SIDELENGTH / 2,y - SIDELENGTH / 2, SIDELENGTH, SIDELENGTH);
//	//	squares.add(current);
//		repaint();
//	}

	/**
	 * Removes a square from the collection.
	 * 
	 * @param s
	 *            the square to remove
	 */
//	public void remove(Rectangle2D s) {
//		if (s == null)
//			return;
//		if (s == current)
//			current = null;
//		squares.remove(s);
//		repaint();
//	}

	private static final int SIDELENGTH = 10;
	private ArrayList<Point2D> points;
	private Point2D currentPoint;

	// the square containing the mouse cursor

	private class MouseHandler extends MouseAdapter {
		public void mousePressed(MouseEvent event) {
			// add a new square if the cursor isn't inside a square
			Point2D point = event.getPoint();
			currentPoint = find(point);
//			if (currentPoint == null)
//				currentPoint.setLocation(currentPoint.getX(), point.getY());
//				add(event.getPoint());
		}

		public void mouseClicked(MouseEvent event) {
			// remove the current square if double clicked
			currentPoint = find(event.getPoint());
//			if (currentPoint != null)
//				currentPoint.setLocation(currentPoint.getX(), y);
		}
	}

	private class MouseMotionHandler implements MouseMotionListener {
		public void mouseMoved(MouseEvent event) {
			// set the mouse cursor to cross hairs if it is inside
			// a rectangle

			if (find(event.getPoint()) == null)
				setCursor(Cursor.getDefaultCursor());
			else
				setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
		}

		public void mouseDragged(MouseEvent event) {
			if (currentPoint != null) {
		
				currentPoint.setLocation(event.getPoint().getX(), event.getPoint().getY());
				// drag the current rectangle to center it at (x, y)
//				current.setFrame(x - SIDELENGTH / 2, y - SIDELENGTH / 2,
//						SIDELENGTH, SIDELENGTH);
				repaint();
			}
		}
	}
}
